# Copyright 2020 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from odoo import models, fields, api
from ast import literal_eval


class ResPartner(models.Model):
    _inherit = 'res.partner'

    project_count = fields.Integer(
        compute='_compute_project_count', 
        string='Nombre de projets',
        store=True)

    def _compute_project_count(self):
        for partner in self:
            porteurs_projects = self.env['res.partner.porteur.project'].search([
                ('partner_id', '=', partner.id)])
            projects = self.env['project.project'].search_count([
                ('porteurs_projets_ids', 'in', porteurs_projects.ids)])
            partner.project_count = projects

    @api.multi
    def action_view_partner_projects(self):
        self.ensure_one()
        action = self.env.ref('project.open_view_project_all_config').read()[0]
        action['domain'] = literal_eval(action['domain'])
        porteurs_projects = self.env['res.partner.porteur.project'].search([
                ('partner_id', '=', self.id)])
        action['domain'].append(('porteurs_projets_ids', 'in', porteurs_projects.ids))
        return action